with Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO, Symmetries, Balls, Square;
use Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO;

  with MPFR.Floats; use MPFR.Floats;
--  with Long_Floats; use Long_Floats;

procedure FixCheck is

  type NRep is new MPFloat;  -- rep used for numeric computations
  type SRep is new MPFloat;  -- rep used to define Scalar

--  type NRep is new Rep;  -- rep used for numeric computations
--  type SRep is new Rep;  -- rep used to define Scalar

  package Scalars is new Balls (Rep => SRep);
  use Scalars;

  type Scalar is new Ball;

  Deg: constant Positive := 125;

  package SQ is new Square (Deg => Deg, NRep => NRep, Scalar => Scalar);
  use SQ;
  use SConstants, SVectors, SVectors_Ops, SFouriers2, SContr;
  subtype Fun is SFourier2;

  DC:     constant Integer := 250;
  Eps:    constant Radius  := 1.0E-15;
  Rad:    constant Radius  := Half**60;
  Lambda: constant Flt     := Flt(145)/Flt(256);
  P:      constant SParam2 := (Scal(Lambda),ScalZero);

  procedure ShowParam is
  begin
    Show_Param;
    Show1("    DC =",DC);
    Show1("   Eps =",Eps);
    Show1("Lambda =",Lambda);
    Show1("   Rad =",Rad);
  end ShowParam;

  F0,F1: Fun;

begin
  Verbosity := 1;
  Set_Precision(128);
  ShowParam;
  Symmetries.Reflect := Symmetries.Trivial'Access;     -- no symmetry

  NumRead("approxfix-200.data",F0);
  F0.T.R := (Rad,Rad);
  F1 := ContrFixA(Scal(Lambda),F0,DC,Eps);
  Write("truefix-125.data",F1);

  CheckNoSymm(F1);

end FixCheck;
