with Ints, Ints.IO, FltStr;
use Ints, Ints.IO;

package body Flts.IO is

  use Flt_IO, Flt_Str;

  procedure Show1(N: in String; R: in Flt; NewLine: in Boolean := True) is
  begin
    Put(N);
    Put(R,3,17,4);
    if NewLine then New_Line; end if;
  end Show1;

  procedure Show2(N: in String; R1,R2: in Flt; NewLine: in Boolean := True) is
  begin
    Put(N);
    Put(R1,3,17,4);
    Put(R2,3,17,4);
    if NewLine then New_Line; end if;
  end Show2;

  procedure Get(F: in File_Type; R: out Flt; Decimal: in Boolean := False) is
    I: Integer := 0;
    S: String(1..32);
  begin
    if Decimal then
      Flt_IO.Get(F,R);
      return;
    end if;
    while I=0 loop
      Get_Line(File=>F, Item=>S, Last=>I);
    end loop;
    R := ValHex(S(1..I));
  end Get;

  procedure Put(F: in File_Type; R: in Flt; Decimal: in Boolean := False) is
  begin
    if Decimal then
      Put(F,R,2,17,4);
    else
      Put(F,HexStr(R));
    end if;
    New_Line(F);
  end Put;

  procedure Plot2(F: in File_Type; R1,R2: in Flt; NewLine: in Boolean := True) is
  begin
    Put(F,R1,3,5,3);
    Put(F," ");
    Put(F,R2,3,5,3);
    if NewLine then New_Line(F); end if;
  end Plot2;

  procedure Plot2(Name: in String; R1,R2: in Flt) is
    F: File_Type;
  begin
    if Name="" then
      Plot2(Standard_Output,R1,R2,True);
      return;
    end if;
    begin
      Open(F,Append_File,Name);
    exception
      when Name_Error => Create(F,Out_File,Name);
    end;
    Plot2(F,R1,R2,False);
    Close(F);
  end Plot2;

  procedure Plot3(F: in File_Type; R1,R2,R3: in Flt; NewLine: in Boolean := True) is
  begin
    Put(F,R1,3,5,3);
    Put(F," ");
    Put(F,R2,3,5,3);
    Put(F," ");
    Put(F,R3,3,5,3);
    if NewLine then New_Line(F); end if;
  end Plot3;

  procedure Plot3(Name: in String; R1,R2,R3: in Flt) is
    F: File_Type;
  begin
    if Name="" then
      Plot3(Standard_Output,R1,R2,R3,True);
      return;
    end if;
    begin
      Open(F,Append_File,Name);
    exception
      when Name_Error => Create(F,Out_File,Name);
    end;
    Plot3(F,R1,R2,R3,False);
    Close(F);
  end Plot3;

end Flts.IO;
