
package body Flts is

  function RMin(R1,R2,R3: Flt) return Flt is
  begin
    return RMin(Rmin(R1,R2),R3);
  end RMin;

  function RMax(R1,R2,R3: Flt) return Flt is
  begin
    return RMax(Rmin(R1,R2),R3);
  end RMax;

  function Min(R1,R2: RadPair) return RadPair is
  begin
    return (RMin(R1(1),R2(1)),RMin(R1(2),R2(2)));
  end Min;

----------------------------------------

  function IsZero(V: RadVector) return Boolean is
  begin
    for N in V'Range loop
      if V(N) /= Zero then return False; end if;
    end loop;
    return True;
  end IsZero;

  function IsZero(A: RadMatrix) return Boolean is
  begin
    for M in A'Range(1) loop
      for N in A'Range(2) loop
        if A(M,N) /= Zero then return False; end if;
      end loop;
    end loop;
    return True;
  end IsZero;

  procedure SetZero(V: in out RadVector) is
  begin
    for N in V'Range loop
      V(N) := Zero;
    end loop;
  end SetZero;

  procedure SetZero(A: in out RadMatrix) is
  begin
    for M in A'Range(1) loop
      for N in A'Range(2) loop
        A(M,N) := Zero;
      end loop;
    end loop;
  end SetZero;

  function ZeroRadVector(F,L: Integer) return RadVector is
    V: RadVector(F..L);
  begin
    for N in V'Range loop
      V(N) := Zero;
    end loop;
    return V;
  end ZeroRadVector;

  function ZeroRadMatrix(F1,L1,F2,L2: Integer) return RadMatrix is
    A: RadMatrix(F1..L1,F2..L2);
  begin
    for M in A'Range(1) loop
      for N in A'Range(2) loop
        A(M,N) := Zero;
      end loop;
    end loop;
    return A;
  end ZeroRadMatrix;

end Flts;
