
package Flts is

  subtype Flt is Long_Long_Float;
  subtype Radius is Flt range Flt(0) .. Flt'Last;

  function RMin(R1,R2: Flt) return Flt renames Flt'Min;
  function RMax(R1,R2: Flt) return Flt renames Flt'Max;
  function RMin(R1,R2,R3: Flt) return Flt;
  function RMax(R1,R2,R3: Flt) return Flt;

  type FltVector is array(Integer range <>) of Flt;
  type FltMatrix is array(Integer range <>, Integer range <>) of Flt;
  type RadVector is array(Integer range <>) of Radius;
  type RadMatrix is array(Integer range <>, Integer range <>) of Radius;
  subtype RadPair is RadVector(1..2);

  function Min(R1,R2: RadPair) return RadPair;
  function IsZero(V: RadVector) return Boolean;
  function IsZero(A: RadMatrix) return Boolean;
  procedure SetZero(V: in out RadVector);
  procedure SetZero(A: in out RadMatrix);
  function ZeroRadVector(F,L: Integer) return RadVector;
  function ZeroRadMatrix(F1,L1,F2,L2: Integer) return RadMatrix;

  Zero:    constant Flt := Flt(0);
  One:     constant Flt := Flt(1);
  Two:     constant Flt := Flt(2);
  Three:   constant Flt := Flt(3);
  Four:    constant Flt := Flt(4);
  Five:    constant Flt := Flt(5);
  NegOne:  constant Flt := Flt(-1);
  Half:    constant Flt := One/Two;
  Quarter: constant Flt := One/Four;
  Tiny:    constant Flt := Flt'Scaling(One,Flt'Machine_Emin);

end Flts;
