with Flts, Long_Floats, Messages, NumFouriers2;
use Flts, Long_Floats, Messages;

procedure FunSamples is

  Deg: constant Positive := GetArg;

  type NRep is new Rep;

  package NF2 is new NumFouriers2 (Deg1 => Deg, Deg2 => Deg, NRep => NRep);
  use NF2.NFouriers2, NF2.NConstants, NF2.Numbers;

  procedure FunCollection is
    R: constant RadPair := (Zero,Zero);
  begin
    Write("AntiBumpsX.data",AntiBumpsX(R));
    Write("AntiBumpsY.data",AntiBumpsY(R));
    Write("AntiBumpsDiag.data",AntiBumpsDiag(R));
    Write("MidPeak1.data",MidPeak(R,1));
    Write("MidHole0.data",MidHole(R,0));
    Write("EdgePeaks1.data",EdgePeaks(R,1));
    Write("CornerPeaks0.data",CornerPeaks(R,0));
    Write("MValley1.data",MValley(R,1));
    Write("PValley1.data",PValley(R,1));
    Write("HVValley0.data",HVValley(R,0));
    Write("MRidge0.data",MRidge(R,0));
    Write("PRidge0.data",PRidge(R,0));
    Write("LR_Peaks1.data",LR_Peaks(R,1));
    Write("BT_Peaks1.data",BT_Peaks(R,1));
    Write("MPeaks1.data",MPeaks(R,1));
    Write("PPeaks1.data",PPeaks(R,1));
    Write("PMPeaks1.data",PMPeaks(R,1));
    Write("LR_Holes0.data",LR_Holes(R,0));
    Write("BT_Holes0.data",BT_Holes(R,0));
    Write("MHoles0.data",MHoles(R,0));
    Write("PHoles0.data",PHoles(R,0));
    Write("PMHoles1.data",PMHoles(R,1));
    Write("HVRidge0.data",HVRidge(R,0));
    Write("EdgeRidge1.data",EdgeRidge(R,1));
    Write("Peaks8-1.data",Peaks8(R,1));
    Write("Perturb5.data",Perturb5(R,ScalOne));
    Write("Perturb7.data",Perturb7(R,ScalOne));
    Write("Perturb8.data",Perturb8(R,ScalOne));
    Write("Perturb9.data",Perturb9(R,ScalOne));
    Write("Perturb10.data",Perturb10(R,ScalOne));
    Write("Perturb13.data",Perturb13(R,ScalOne));
    Write("Perturb11-97:128.data",Perturb11(R,Scal(97)/Scal(128)));
    Write("Perturb13-145:256.data",Perturb13(R,Scal(145)/Scal(256)));
  end FunCollection;

begin

  FunCollection;

end FunSamples;
