
package body Ints.IO is

  function Val(C: Character; VMax: Positive) return Natural is
  begin
    for L in 0 .. VMax loop
      if C=UpDig(L) then return L; end if;
    end loop;
    for L in 0 .. VMax loop
      if C=LoDig(L) then return L; end if;
    end loop;
    raise Data_Error;
    return 0;
  end Val;

  function Value(S: String; Base: Positive) return Integer is
    VMax: constant Positive := Base-1;
    Sig: Integer := 1;
    I: Integer := 0;
  begin
    for K in S'Range loop
      if S(K)='-' then
        Sig := -1;
      elsif S(K) /= ' ' and then S(K) /= '+' then
        I := Base*I+Val(S(K),VMax);
      end if;
    end loop;
    return Sig*I;
  end Value;

  function Image(I: Integer; Base: Positive; ShowPlus: Boolean) return String is
  begin
    if I<0 then
      return "-" & Image(abs(I),Base,False);
    elsif ShowPlus then
      return "+" & Image(I,Base,False);
    else
      declare
        L: constant Positive := Width(I,Base);
        K: Integer := I;
        S: String(1..L);
      begin
        for N in reverse 1 .. L loop
          S(N) := UpDig(K mod Base);
          K := K/Base;
        end loop;
        return S;
      end;
    end if;
  end Image;

  function Strng(I: Integer; W: Positive) return String is
    S: String(1 .. W);
  begin
    Int_IO.Put(S,I);
    return S;
  end Strng;

  function Strng(I: Integer) return String is
  begin
    return Strng(I, Width(I));
  end Strng;

  procedure Get(F: in File_Type; I: out Integer) is
  begin
    Int_IO.Get(F,I);
  end Get;

  function Get(F: File_Type; VFirst: Integer) return IntVector is
    L: Integer;
  begin
    Get(F,L);
    declare
      VLast: constant Integer := VFirst+L-1;
      V: IntVector(VFirst..VLast);
    begin
      for M in VFirst .. VLast loop
        Get(F,V(M));
      end loop;
      return V;
    end;
  end Get;

  procedure Put(F: in File_Type; I: in Integer; NewLine: in Boolean := True) is
  begin
    Int_IO.Put(F,I,Width(I)+1);
    if NewLine then New_Line(F); end if;
  end Put;

  procedure Put(F: in File_Type; V: in IntVector) is
    L: constant Integer := V'Last;
    D: constant Integer := L-V'First+1;
  begin
    Put(F,D);
    for I in V'First .. L loop
      Put(F,V(I));
   end loop;
  end Put;

  procedure Show0(N: in String; NewLine: in Boolean := True) is
  begin
    Put(N);
    if NewLine then New_Line; end if;
  end Show0;

  procedure Show1(N: in String; I: in Integer; NewLine: in Boolean := True) is
  begin
    Put(N);
    Int_IO.Put(I,Width(I)+1);
    if NewLine then New_Line; end if;
  end Show1;

  procedure Show2(N: in String; I1,I2: in Integer; NewLine: in Boolean := True) is
  begin
    Put(N);
    Int_IO.Put(I1,Width(I1)+1);
    Int_IO.Put(I2,Width(I2)+5);
    if NewLine then New_Line; end if;
  end Show2;

  procedure Show1(N: in String; V: in IntVector; NewLine: in Boolean := True) is
    W: constant Positive := 4;
  begin
    for I in V'Range loop
      if V(I) /= 0 then
        Show1(N & Strng(I,W),V(I));
      end if;
    end loop;
    if NewLine then New_Line; end if;
  end Show1;

  procedure Show1(N: in String; A: in IntMatrix; NewLine: in Boolean := True) is
    W: constant Positive := 4;
  begin
    for I in A'Range(1) loop
      for J in A'Range(2) loop
        if A(I,J) /= 0 then
          Show1(N & Strng(I,W) & Strng(J,W),A(I,J));
        end if;
      end loop;
    end loop;
    if NewLine then New_Line; end if;
  end Show1;

end Ints.IO;
