
package body Long_Floats is

  RepZero: constant Rep := Rep(0);

  function IsZero(R: Rep) return Boolean is
  begin
    return (R=RepZero);
  end IsZero;

  procedure SetZero(R: in out Rep) is
  begin
    R := RepZero;
  end SetZero;

  function Sign(R: Rep) return Integer is
  begin
    if R>RepZero then return 1;
    elsif R<RepZero then return -1;
    else return 0; end if;
  end Sign;

  procedure Swap(R1,R2: in out Rep) is
    R: constant Rep := R1;
  begin
    R1 := R2; R2 := R;
  end Swap;

  function Compare(R1,R2: Rep) return Integer is
  begin
    if R2>R1 then return 1;
    elsif R2<R1 then return -1;
    else return 0; end if;
  end Compare;

  function "*"(F: Flt; R: Rep) return Rep is
  begin
    return Rep(F)*R;
  end "*";

  function Convert(R: Rep) return Flt is
  begin
    return Flt(R);
  end Convert;

  function ApproxPut(R: Rep) return FltVector is
    V: FltVector(1..1);
  begin
    V(1) := Flt(R);
    return V;
  end ApproxPut;

  function ApproxGet(V: FltVector) return Rep is
  begin
    return Rep(V(1));
  end ApproxGet;

  function Val(I: Integer) return Rep is
  begin
    return Rep(I);
  end Val;

  function Val(F: Flt) return Rep is
  begin
    return Rep(F);
  end Val;

  function Rounded_Last_Conversion return Boolean is
  begin
    return Rep_FS.Rounded_Last;
  end Rounded_Last_Conversion;

  procedure Set_Precision(Dummy: in Rep; Binary_Digs: in Positive) is
    D: constant Positive := Rep'Machine_Mantissa;
  begin
    if Binary_Digs /= D then
      Put_Line("warning: precision is fixed to " & Strng(D));
    end if;
  end Set_Precision;

  function Get_Precision(R: Rep) return Positive is
  begin
    return Rep'Machine_Mantissa;
  end Get_Precision;

  procedure Set_Rounding_Up(Dummy: in Rep) is
  begin
    Rounding.Set_Rounding_Up;
  end Set_Rounding_Up;

  procedure Set_Rounding_Down(Dummy: in Rep) is
  begin
    Rounding.Set_Rounding_Down;
  end Set_Rounding_Down;

  procedure Set_Rounding_Nearest(Dummy: in Rep) is
  begin
    Rounding.Set_Rounding_Nearest;
  end Set_Rounding_Nearest;

  procedure Set_Rounding_Truncate(Dummy: in Rep) is
  begin
    Rounding.Set_Rounding_Truncate;
  end Set_Rounding_Truncate;

  procedure Set_Rounding_Relaxed(Dummy: in Rep) is
  begin
    Rounding.Set_Rounding_Relaxed;
  end Set_Rounding_Relaxed;

end Long_Floats;
