with Ints, Flts, Ada.Real_Time;
use Ints, Flts, Ada.Real_Time;

package Messages is

  pragma Elaborate_Body;

  procedure Show(S: in String; Skip: in Natural := 0; NewLine: in Boolean := True);
  procedure Show(S: in String; R: in Flt; Skip: in Natural := 0);
  procedure Show(S: in String; R1,R2: in Flt; Skip: in Natural := 0);
  procedure Error(S: in String; Skip: in Natural := 0);
  procedure Error(S: in String; R: in Flt; Skip: in Natural := 0);
  procedure Error(S: in String; R1,R2: in Flt; Skip: in Natural := 0);

  procedure TraceEnter(Where: in String);
  procedure TraceLeave;

  function GetArg return Boolean;  -- get next command line argument
  function GetArg return Integer;
  function GetArg return String;
  function GetArg return Flt;      -- careful, input may get rounded

  subtype Timer is Time;
  function Reset_Timer return Timer renames Clock;
  function Age(T: in Timer) return Flt;
  function Seconds(T: in Timer) return Integer;
  function Minutes(T: in Timer) return Integer;
  function Hours(T: in Timer) return Integer;

  ArgIndex:   Positive := 1;
  DefaultAft: Positive := 3;
  DefaultExp: Positive := 3;

  Verbosity: Natural := 0;  --- 0: just error messages and important warnings
                            --- 1: also high level program info
                            --- 2: also TraceEnter and TraceLeave
                            --- 3: also domain errors with info in numeric programs
                            --- 4: more stuff
                            --- 5: everything
private

  Indent: Natural := 0;
  Dots: constant String := ". . . . . . . . . . . . . . . . . . . . . . . . . . ";

end Messages;
