with Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO, Symmetries, Numerics, Square;
use Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO, Symmetries;

with Long_Floats; use Long_Floats;

procedure Plotting is

  type NRep is new Rep;  -- rep used for numeric computations
  type SRep is new Rep;  -- rep used to define Scalar

  package Scalars is new Numerics (Rep => SRep);
  use Scalars;

  Deg: constant Positive := 30;

  package SQ is new Square (Deg => Deg, NRep => NRep, Scalar => Numeric);
  use SQ, SQ.SFouriers2;

  subtype Fun is SFourier2;

  Name: constant String := GetArg;

  F: Fun;

begin

  Read(Name,F);
  Plot(F);

end Plotting;
