with System.Machine_Code;
use System.Machine_Code;

pragma Optimize (Off);

package body Rounding is

  procedure Load_Control_Word(W: in Rounding_Mode) is
  begin
--- clear exception flags after handling pending unmaked exceptions
    Asm("fclex",Volatile => True);
--- load control word into FPU
    Asm("fldcw %0",Inputs => Rounding_Mode'Asm_Input("g",W), Volatile => True);
  end Load_Control_Word;

  procedure Set_Rounding_Up is
  begin
    Load_Control_Word(Up);
    Current_Rounding_Mode := Up;
  end Set_Rounding_Up;

  procedure Set_Rounding_Down is
  begin
    Load_Control_Word(Down);
    Current_Rounding_Mode := Down;
  end Set_Rounding_Down;

  procedure Set_Rounding_Nearest is
  begin
    Load_Control_Word(Nearest);
    Current_Rounding_Mode := Nearest;
  end Set_Rounding_Nearest;

  procedure Set_Rounding_Truncate is
  begin
    Load_Control_Word(Truncate);
    Current_Rounding_Mode := Truncate;
  end Set_Rounding_Truncate;

  procedure Set_Rounding_Relaxed is
  begin
    Load_Control_Word(Relaxed);
    Current_Rounding_Mode := Relaxed;
  end Set_Rounding_Relaxed;

  function Get_Rounding_Mode return Rounding_Mode is
  begin
    return Current_Rounding_Mode;
  end Get_Rounding_Mode;

begin

  Set_Rounding_Relaxed;
  Current_Rounding_Mode := Relaxed;

end Rounding;
