with Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO, Numerics;
use Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO;
with Vectors, Vectors.Ops, Vectors.Num;

--with Long_Floats; use Long_Floats;
with MPFR.Floats; use MPFR.Floats;

procedure ShowEigen is

--  type NRep is new Rep;
  type NRep is new MPFloat;

  package Scalars is new Numerics (Rep => NRep);
  use Scalars;

  type Scalar is new Numeric;
  package Vecs is new Vectors (Scalar => Scalar);
  package Vecs_Ops is new Vecs.Ops;
  package Vecs_Num is new Vecs.Num;
  use Vecs, Vecs_Num;

  Name: constant String := GetArg;

  function GetDim return Integer is
    D: Integer;
    F: File_Type;
  begin
    Open(F,In_File,Name);
    Get(F,D);
    Close(F);
    return D;
  end GetDim;

  Dim: constant Integer := GetDim;
  Wr,Wi: Vector(1..Dim);
  B,Vr,Vi: Matrix(1..Dim,1..Dim);

begin

  Read(Name,B);
  Eigen(B,Wr,Wi,Vr,Vi);
  Show0("Eigenvalues");
  Show2("W ",Wr,Wi);

  for J in 1 .. 3 loop
    New_Line;
    Show0("Eigenvector" & Strng(J,3));
    Wr := GetColumn(J,Vr);
    Wi := GetColumn(J,Vi);
    Show2("V ",Wr,Wi);
  end loop;

end ShowEigen;
