  with Ada.Text_IO, Messages, Ints, Flts;
use Ada.Text_IO, Messages, Ints, Flts;
with Balls, Constants, Vectors, Vectors.Ops, Vectors.Num, Fouriers2;

with Long_Floats; use Long_Floats;
--with MPFR.Floats; use MPFR.Floats;

procedure ShowFun2 is

  type SRep is new Rep;
--  type SRep is new MPFloat;

  package Scalars is new Balls (Rep => SRep);
  use Scalars;
  type Scalar is new Ball;

  Deg: constant Positive := GetArg;

  package SConstants is new Constants (Scalar => Scalar);
  package SVectors is new Vectors (Scalar => Scalar);
  package SVectors_Ops is new SVectors.Ops;
  package SVectors_Num is new SVectors.Num;
  package SFouriers2 is new Fouriers2 (Deg1 => Deg, Deg2 => Deg, Scalar => Scalar,
          SC => SConstants, SV => SVectors, SV_Ops => SVectors_Ops, SV_Num => SVectors_Num);
  use SFouriers2;

  Name1: constant String := GetArg;
  Name2: constant String := GetArg;

  F1,F2: Fourier2;

begin
  Set_New_Precision(ScalZero,128);

  Read(Name1,F1);
  Read(Name2,F2);
  Show2("",F1,F2);

end ShowFun2;
