with Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO, Symmetries, Balls, Square;
use Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO;

--with Long_Floats; use Long_Floats;
with MPFR.Floats; use MPFR.Floats;

procedure Spectrum is

--  type NRep is new Rep;  -- rep used for numeric computations
--  type SRep is new Rep;  -- rep used to define Scalar

  type NRep is new MPFloat;  -- rep used for numeric computations
  type SRep is new MPFloat;  -- rep used to define Scalar

  package Scalars is new Balls (Rep => SRep);
  use Scalars;
  type Scalar is new Ball;

  Deg: constant Positive := 100;

  package SQ is new Square (Deg => Deg, NRep => NRep, Scalar => Scalar);
  use SQ;
  use SConstants, SVectors, SVectors_Ops, SFouriers2, SContr;
  subtype Fun is SFourier2;

  LSize:  constant Integer := 250;
  Rad:    constant Radius  := Half**60;
  Lambda: constant Flt     := Flt(145)/Flt(256);
  P:      constant SParam2 := (Scal(Lambda),ScalZero);

  procedure ShowParam is
  begin
    Show_Param;
    Show1(" LSize =",LSize);
    Show1("Lambda =",Lambda);
    Show1("   Rad =",Rad);
  end ShowParam;

  F: Fun;
  B: SSimDiag(LSize);

begin
  Verbosity := 2;
  Set_Precision(256);
  ShowParam;
  Symmetries.Reflect := Symmetries.Trivial'Access;     -- no symmetry

  NumRead("approxfix-200.data",F);
  DMapAData(Scal(Lambda),F,B);

  Read("truefix-125.data",F);
  CheckEigen(Scal(Lambda),F,B);
end Spectrum;
