with Ada.Text_IO, Ints, Ints.IO, Flts;
use Ada.Text_IO, Ints, Ints.IO, Flts;

package Symmetries is

  procedure Trivial(M,N: in Natural; Swap: out Boolean; Sig: out Flt);
  procedure XReflect(M,N: in Natural; Swap: out Boolean; Sig: out Flt);
  procedure YReflect(M,N: in Natural; Swap: out Boolean; Sig: out Flt);
  procedure DiagReflect(M,N: in Natural; Swap: out Boolean; Sig: out Flt);
  procedure RotatePi(M,N: in Natural; Swap: out Boolean; Sig: out Flt);

  type Symmetry is access procedure(M,N: in Natural; Swap: out Boolean; Sig: out Flt);

  Reflect: Symmetry := Trivial'Access;            -- default symmetry

--- all depends on Reflect
  procedure Coord(K: in Positive; M,N: out Natural);
  function Deg(K: Positive) return Positive;
  function MaxInvDeg(D: Positive) return Positive;
  procedure ShowModes(NMax: in Positive);

private

  type ModeInfo is
    record
      M,N,D: Natural := 0;
    end record;

  NPack: constant Integer := 32768;
  PackSymmetry: Symmetry := null;
  PackIndex: array(1 .. NPack) of ModeInfo;

  procedure NextMode(M,N: in Integer; K: in out Integer);
  procedure MakePackIndex;
  procedure Show(M,N: in Natural; Sig: in Flt; NewLine: in Boolean);

end Symmetries;
