with Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO, Balls;
use Ada.Text_IO, Messages, Ints, Ints.IO, Flts, Flts.IO;
with Constants, Vectors, Vectors.Ops, Vectors.Num;

--with Long_Floats; use Long_Floats;
with MPFR.Floats; use MPFR.Floats;

procedure TestVecs is

--  type SRep is new Rep;
  type SRep is new MPFloat;

  package Scalars is new Balls (Rep => SRep);
  use Scalars;

  type Scalar is new Ball;
  package Consts is new Constants (Scalar => Scalar);
  package Vecs is new Vectors (Scalar => Scalar);
  package Vecs_Ops is new Vecs.Ops;
  package Vecs_Num is new Vecs.Num;
  use Consts, Vecs, Vecs_Ops;

  Dim: constant Positive := 3;

  function E1(K: Integer) return Vector is
    V: Vector(1 .. Dim);
  begin
    SetZero(V);
    V(K) := Scal(1);
    return V;
  end E1;

  function M1 return Matrix is
    A: Matrix(1..3,1..3);
  begin
    A(1,1) := Scal( 2);
    A(1,2) := Scal( 1);
    A(1,3) := Scal( 1);
    A(2,1) := Scal( 2);
    A(2,2) := Scal( 3);
    A(2,3) := Scal( 4);
    A(3,1) := Scal(-1);
    A(3,2) := Scal( 1);
    A(3,3) := Scal( 2);
    return A;
  end M1;

  function U1 return Matrix is
    A: Matrix := M1;
  begin
    for I in 1 .. 3 loop
      for J in 1 .. I-1 loop
        SetZero(A(I,J));
      end loop;
    end loop;
    return A;
  end U1;

  function L1 return Matrix is
    A: Matrix := M1;
  begin
    for I in 1 .. 3 loop
      for J in I+1 .. 3 loop
        SetZero(A(I,J));
      end loop;
    end loop;
    return A;
  end L1;

  V,V1,V2,V3: Vector(1..Dim);
  A,L,U,A1,A2,A3: Matrix(1..Dim,1..Dim);
  T,T1,T2,T3: LUData(Dim);


begin
  Verbosity := 1;
  Set_New_Precision(ScalZero,128);


  A := M1;
  Decomp(A,T);

  V := E1(1);
  Solve(A,V,V1);
  Mult(A,V1);
  Show2("V V1",V,V1);


return;

  Convert(T,A1);
  Show2(" A  A1",A,A1);
  Invert(T,A1);
  Show1("A/A",A*A1);

end TestVecs;
